(**
   This provides a printing function for debugging.
   @author Naoki Nishida
   @since 2016/11/20
*)

(**
   A flag for using the debug mode.
*)
let debugmode = ref false;;

(**
   A prompt for printing in the debug mode.
*)
let debugprompt = ref "--> ";;
   
(**
   This sets [debugmode] to [true].
*)
let set_debugmode () = debugmode := true;;

(**
   This sets [debugmode] to [true].
*)
let unset_debugmode () = debugmode := false;;

(**
   This sets [debugprompt] to input strings.
*)
let set_debugprompt s = debugprompt := s;;

(**
   This prints input strings if in the debug mode.
*)
let debug s =
  if !debugmode 
  then 
    print_string (!debugprompt ^ s)
  else
    ();;

   

