(**
   This is a module on termination.
@author Naoki Nishida
@since 2014/06/27
@since 2017/08/03
*)

open Ctrs;;
open Dp;;

(**
   This is an original weight function for function symbols.
*)
let weight f =
  begin
    match f with
      ("bot",None) -> 100
    | _ -> 1
  end;;
    
(**
   This is an indentity weight function.
*)
let id _ = 1;;
    
(**
   This validates termination of a given TRS.
*)
let is_SN_by_natt spec =
  let cmd = "sh ./natt.sh" in
    let (ch_in, ch_out) = Unix.open_process cmd in
      output_string ch_out (string_of_ctrs 0 spec);
      close_out ch_out;
      let line = (input_line ch_in) in
      let _= Unix.close_process (ch_in, ch_out) in
      match line with
	"YES" -> Some true
      | "NO" -> Some false
      | _ -> None;;

(*
let is_SN_by_aprove spec =
  let cmd = "sh ./aprove.sh" in
    let (ch_in, ch_out, ch_err) = Unix.open_process_full cmd [|  |] in
      output_string ch_out (string_of_ctrs_for_aprove 0 spec);
      close_out ch_out;
      let line = (input_line ch_in) in
      let _ = Unix.close_process_full (ch_in, ch_out, ch_err) in
      match line with
	"YES" -> Some true
      | "NO" -> Some false
      | _ -> None;;
*)
	    
let is_SN_by_aprove spec =
  let file = "temp.trs" in
  let fp = open_out file in
  let cmd = "sh ./aprove.sh "^file in
  Printf.fprintf fp "%s" (string_of_ctrs 0 spec);
  close_out fp;
  let (ch_in, ch_out) = Unix.open_process cmd in
  close_out ch_out;
  let line = (input_line ch_in) in
  let _ = Unix.close_process (ch_in, ch_out) in
      match line with
	"YES" -> Some true
      | "NO" -> Some false
      | _ -> None;;
	
let is_SN_by_co3 spec =
  if List.for_all (is_size_decreasing weight) spec.rules
  then
    Some true
  else
    dpframework weight spec;;

let is_SN spec = is_SN_by_co3 spec;;
